node{
    def sonarOrgKey = "cours-eftl-ggestin"
    def sonarProjectKey = "${sonarOrgKey}_projet_anthony"

    try{
        stage('Checkout'){
            checkout scm
            def pom = readMavenPom file: 'pom.xml'
            if (pom){
                echo "Building version ${pom.version}"
            }
            sh "chmod +x ./mvnw"
        }
        stage("build"){
            sh "./mvnw package -DskipTests"
        }

        stage("quality analysis"){
            def skipTests= ''
            if( env.SKIP_TESTS.toBoolean() )   {
                skipTests = '--DskipTests'
            }
            //echo env.SONAR_TOKEN
            sh "./mvnw verify org.sonarsource.scanner.maven:sonar-maven-plugin:3.9.0.2155:sonar -Dsonar.projectKey=${sonarProjectKey}"
        }

        //stage("quality analysis"){
       //     sh "./mvnw verify org.sonarsource.scanner.maven:sonar-maven-plugin:3.9.0.2155:sonar -Dsonar.projectKey=${sonarProjectKey}"
        //}

    }catch (Exception error){
        // send mail, notification
        throw error
    } finally{
        archiveArtifacts '**/target/*.jar'
        junit allowEmptyResults: true, skipMarkingBuildUnstable: true, skipPublishingChecks: true, testResults: '**/target/surefire-reports/*.xml'
    }

    
}
